import React from 'react';
import Uuid from 'uuid';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import './progress-spinner.less';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faSpinner } from '@fortawesome/free-solid-svg-icons';

export default function ProgressSpinner({
    color,
    id,
    size,
    subClass
}) {
    const className = classnames(
        'tsdev-progress-spinner', subClass
    );

    return (
        <div id={id}
            className={className}>
            <FontAwesomeIcon icon={faSpinner}
                color={color}
                size={size}
                pulse />
        </div >
    );
}

ProgressSpinner.propTypes = {
    color: PropTypes.string,
    id: PropTypes.string,
    size: PropTypes.string,
    subClass: PropTypes.string
};

ProgressSpinner.defaultProps = {
    color: '#1976d2',
    id: `tsdevProgressSpinner-${Uuid.v4()}`,
    size: '6x', // lg,xs,sm,1x,2x,3x,4x,5x,6x,7x,8x,9x,10x
    subClass: ''
};

ProgressSpinner.displayName = 'ProgressSpinner';
